/*
 *++
COPYRIGHT:
This file is part of the GSM Suite, a set of programs for
manipulating state machines in a graphical fashion.
Copyright (C) 1996, 1997  G. Andrew Mangogna.

LICENSE:
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the
Free Software Foundation, Inc.,
59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.

MODULE:

$RCSfile: TextWidgetStreamBuf.cc,v $
$Revision: 1.4 $
$Date: 1997/07/02 04:44:56 $

ABSTRACT:

CONDITIONAL COMPILATION:

MODIFICATION HISTORY:
$Log: TextWidgetStreamBuf.cc,v $
Revision 1.4  1997/07/02 04:44:56  andrewm
Added copyright and license notices to the tops of the files.

Revision 1.3  1997/02/23 23:44:09  andrewm
Checkpoint.  Things seem to be working reasonably well.

Revision 1.2  1996/09/22 01:46:34  andrewm
pre-alpha release

// Revision 1.1  1996/07/13  19:32:43  andrewm
// Initial revision
//
// Revision 1.1  1996/07/13  19:32:43  andrewm
// Initial revision
//
 *--
 */

/*
PRAGMAS
*/
#ifdef __GNUG__
#	pragma implementation
#endif /* __GNUG__ */

/*
INCLUDE FILES
*/
#include "TextWidgetStreamBuf.h"
#include <Xm/Text.h>

/*
MACRO DEFINITIONS
*/

/*
TYPE DEFINITIONS
*/

/*
EXTERNAL FUNCTION REFERENCES
*/

/*
FORWARD FUNCTION REFERENCES
*/

/*
FORWARD CLASS REFERENCES
*/

/*
EXTERNAL DATA REFERENCES
*/

/*
EXTERNAL DATA DEFINITIONS
*/

/*
STATIC DATA ALLOCATION
*/
static char rcsid[] = "@(#) $RCSfile: TextWidgetStreamBuf.cc,v $ $Revision: 1.4 $" ;

/*
STATIC MEMBER DEFINITIONS
*/

/*
FUNCTION DEFINITIONS
*/

TextWidgetStreamBuf::
TextWidgetStreamBuf(
	Widget text_widget) :
		_widget(text_widget)
{
	setp(_buf, _buf + sizeof(_buf)) ;
}

int TextWidgetStreamBuf::
sync()
{
	streamsize n = pptr() - pbase() ;
	return (n && post_to_widget(pbase(), n) != n) ? EOF : (pbump(-n), 0) ;
}

int TextWidgetStreamBuf::
overflow(
	int ch)
{
	streamsize n = pptr() - pbase() ;
	if (n && sync())
		return EOF ;
	if (ch != EOF)
		sputc(ch) ;
	return 0 ;
}

streamsize TextWidgetStreamBuf::
xsputn(
	char *text,
	streamsize n)
{
	return sync() == EOF ? 0 : post_to_widget(text, n) ;
}

int TextWidgetStreamBuf::
post_to_widget(
	char *text,
	int length)
{
	char buf[length + 1] ;
	memcpy(buf, text, length) ;
	buf[length] = '\0' ;

	XmTextPosition last_pos = XmTextGetLastPosition(_widget) ;
	XmTextInsert(_widget, last_pos, buf) ;
	XtVaSetValues(_widget, XmNcursorPosition, last_pos, NULL) ;
	XmTextShowPosition(_widget, last_pos) ;

	return length ;
}
