/*
 *++
COPYRIGHT:
This file is part of the GSM Suite, a set of programs for
manipulating state machines in a graphical fashion.
Copyright (C) 1996, 1997  G. Andrew Mangogna.

LICENSE:
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the
Free Software Foundation, Inc.,
59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.

MODULE:

$RCSfile: CcHeaderVisitor.h,v $
$Revision: 1.3 $
$Date: 1997/07/02 04:45:21 $

ABSTRACT:

CONDITIONAL COMPILATION:

MODIFICATION HISTORY:
$Log: CcHeaderVisitor.h,v $
Revision 1.3  1997/07/02 04:45:21  andrewm
Added copyright and license notices to the tops of the files.

Revision 1.2  1996/12/26 05:55:27  andrewm
Checkpoint, the compiler is working again.

Revision 1.1  1996/09/22 01:18:50  andrewm
pre-alpha release

 * Revision 1.1  1996/06/26  03:18:36  andrewm
 * Initial revision
 *
 *--
 */
#ifndef _CcHeaderVisitor_h_
#define _CcHeaderVisitor_h_

/*
PRAGMAS
*/
#ifdef __GNUG__
#	pragma interface
#endif /* __GNUG__ */

/*
INCLUDE FILES
*/
#include <string>
#include <fstream.h>

#include "MachineVisitor.h"

/*
MACRO DEFINITIONS
*/

/*
CLASS DEFINITIONS
*/

class CcHeaderVisitor :
	public MachineVisitor
{
public:
	CcHeaderVisitor(const string& filename) ;

	virtual void visit(MachineGroup *machine_group) ;
	virtual void visit(Smachine *machine) ;

private:
	string _filename ;
	ofstream _headerfile ;
	string _include_define ;
} ;



#endif /* _CcHeaderVisitor_h_ */
